/*
=========================================
SQLiteModule.ahk
SQLitep֐Q
=========================================
*/

;O[oϐQ
;nkf̃W[
$nkf_Module =
;SQLiteitẽW[
$SQLite_Module =
;G[bZ[W
$errMsg =

;ȉ֐
;=========================================
;nkf_Start()
;nkfJn
;@:Ȃ
;߂l: = True
;      :s = False
;=========================================
nkf_Start()
{
  global
  $nkf_Module := DllCall("LoadLibrary", "Str", "nkf32.dll")
  if(ErrorLevel <> 0)
  {
    $errMsg = nkf_Start:LoadLibraryG[
    return False
  }
  return True
}

;=========================================
;nkf_Stop()
;nkfI
;@:Ȃ
;߂l: = True
;      :s = False
;=========================================
nkf_Stop()
{
  global
  $errMsg := ""
  DllCall("FreeLibrary", "UInt", $nkf_Module)
  if(ErrorLevel <> 0)
  {
    $errMsg = nkf_Stop:FreeLibraryG[
    return False
  }
  return True
}

;=========================================
;nkf(text, option)
;nkfgpĕR[hϊ
;@:text
;       ϊϐ
;      :option
;       nkf̕ϊIvVw肷
;߂l: = newtext
;                ϊϐ
;      :s = False
;=========================================
nkf(text, option)
{
  global $errMsg
  $errMsg := ""
  newtext := ""
  DllCall("nkf32.dll\SetNkfOption", "Str", option)
  if(ErrorLevel <> 0)
  {
    $errMsg = nkf:SetNkfOptionG[
    return False
  }
  DllCall("nkf32.dll\NkfConvert", "Str", newtext, "Str", text)
  if(ErrorLevel <> 0)
  {
    $errMsg = nkf:NkfConvertG[
    return False
  }
  return newtext
}

;=========================================
;nkf_FileConvert(file, option)
;nkfgpăt@C̕R[hϊ
;@:file
;       ϊt@C
;      :option
;       nkf̕ϊIvVw肷
;߂l: = True
;      :s = False
;=========================================
nkf_FileConvert(file, option)
{
  global $errMsg
  $errMsg := ""
  if(!FileExist(file))
  {
    $errMsg = nkf_FileConvert:%file%݂܂
    return False
  }
  DllCall("nkf32.dll\SetNkfOption", "Str", option)
  if(ErrorLevel <> 0)
  {
    $errMsg = nkf_FileConvert:SetNkfOptionG[
    return False
  }
  DllCall("nkf32.dll\NkfFileConvert1", "Str", file)
  if(ErrorLevel <> 0)
  {
    $errMsg = nkf_FileConvert:NkfFileConvert1G[
    return False
  }
  return True
}

;=========================================
;nkf_ToSJIS(ByRef text)
;nkfgpĕR[hShiftJISɕϊ
;@:text
;       ϊϐ
;߂l: = True
;      :s = False
;=========================================
nkf_ToSJIS(ByRef text)
{
  global $errMsg
  $errMsg := ""
  option = -s
  DllCall("nkf32.dll\SetNkfOption", "Str", option)
  if(ErrorLevel <> 0)
  {
    $errMsg = nkf_ToSJIS:SetNkfOptionG[
    return False
  }
  VarSetCapacity(newtext, StrLen(text))
  DllCall("nkf32.dll\NkfConvert", "Str", newtext, "Str", text)
  if(ErrorLevel <> 0)
  {
    $errMsg = nkf_ToSJIS:NkfConvertG[
    return False
  }
  text := newtext
  return True
}

;=========================================
;nkf_ToUTF8(ByRef text)
;nkfgpĕR[hUTF8ɕϊ
;@:text
;       ϊϐ
;߂l: = True
;      :s = False
;=========================================
nkf_ToUTF8(ByRef text)
{
  global $errMsg
  $errMsg := ""
  option = -w
  DllCall("nkf32.dll\SetNkfOption", "Str", option)
  if(ErrorLevel <> 0)
  {
    $errMsg = nkf_ToUTF8:SetNkfOptionG[
    return False
  }
  VarSetCapacity(newtext, StrLen(text) * 1.5)
  DllCall("nkf32.dll\NkfConvert", "Str", newtext, "Str", text)
  if(ErrorLevel <> 0)
  {
    $errMsg = nkf_ToUTF8:NkfConvertG[
    return False
  }
  text := newtext
  return True
}

;=========================================
;SQLite_Start()
;SQLiteJn
;@:Ȃ
;߂l: = True
;      :s = False
;=========================================
SQLite_Start()
{
  global $SQLite_Module, $errMsg
  $errMsg := ""
  $SQLite_Module := DllCall("LoadLibrary", "Str", "sqlite3.dll")
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_Start:LoadLibraryG[
    return False
  }
  if(!nkf_Start())
  {
    $errMsg = SQLite_Start->%$errMsg%
    return False
  }
  return True
}

;=========================================
;SQLite_Stop()
;SQLiteI
;@:Ȃ
;߂l: = True
;      :s = False
;=========================================
SQLite_Stop()
{
  global $SQLite_Module, $errMsg
  $errMsg := ""
  if(!nkf_Stop())
  {
    $errMsg = SQLite_Stop->%$errMsg%
    return False
  }
  DllCall("FreeLibrary", "UInt", $SQLite_Module)
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_Stop:FreeLibraryG[
    return False
  }
}

;=========================================
;SQLite_OpenDB(ByRef dbName, ByRef db)
;DBJ
;@:dbName
;       dbo^Ăt@C
;@@@:db
;       Ȍgpϐ
;߂l: = True
;      :s = False
;=========================================
SQLite_OpenDB(dbName, ByRef db)
{
  global $errMsg
  $errMsg := ""
  DllCall("sqlite3\sqlite3_open",  "Str", dbName
  , "Uint *", db
  , "Cdecl int")
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_OpenDB:sqlite3_openG[
    return False
  }
  return True
}

;=========================================
;SQLite_CloseDB(ByRef db)
;SQLite
;@:db
;       SQLite_OpenDBŎw肵ϐ
;߂l: = True
;      :s = False
;=========================================
SQLite_CloseDB(ByRef db)
{
  global $errMsg
  $errMsg := ""
  DllCall("sqlite3\sqlite3_close", "Uint", db
  , "Cdecl int")
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_CloseDB:sqlite3_closeG[
    return False
  }
  return True
}

;=========================================
;SQLite_Table_Exist(db, searchTable)
;w肵e[u݂邩ǂmF
;@:db
;       SQLite_OpenDBŎw肵ϐ
;      :text
;       e[u
;߂l:݂ = True
;      :݂Ȃ = False
;=========================================
SQLite_Table_Exist(db, searchTable)
{
  sql = SELECT count(*) FROM sqlite_master WHERE type='table' AND name='%searchTable%';
  ;SQLite_GetSelectƂ낢Ɩ肪oĂ̂łőΏ
  nkf_ToUTF8(sql)
  SQLite_Prepare(db, sql, query, nextSql)
  SQLite_Step(query)
  SQLite_Column_Integer(query, 0, result)
  SQLite_Finalize(query)
  if(result < 1)
  {
    return False
  }
  return True
}

;=========================================
;SQLite_Value_Exist(db, searchName, tableName, columnName)
;searchNameŎw肵l݂邩ǂmF
;@:db
;       SQLite_OpenDBŎw肵ϐ
;      :searchName
;       L[̒l
;       (LikewȂ̂%_Ȃǎw\)
;      :tableName
;       e[u
;      :columnName
;       J
;߂l:݂ = True
;      :݂Ȃ = False
;=========================================
SQLite_Value_Exist(db, searchName, tableName, columnName)
{
  sql = SELECT count(*) FROM %tableName% WHERE %columnName% LIKE('%searchName%');
  ;SQLite_GetSelectƂ낢Ɩ肪oĂ̂łőΏ
  nkf_ToUTF8(sql)
  SQLite_Prepare(db, sql, query, nextSql)
  SQLite_Step(query)
  SQLite_Column_Integer(query, 0, result)
  SQLite_Finalize(query)
  if(result < 1)
  {
    return False
  }
  return True
}

;=========================================
;SQLite_Exec(ByRef db, ByRef sql)
;߂l̂ȂSQLites
;(SELECTȊO)
;@:db
;       SQLite_OpenDBŎw肵ϐ
;      :sql
;       sSQLite̕ϐ
;߂l: = True
;      :s = False
;=========================================
SQLite_Exec(db, sql)
{
  global $errMsg
  $errMsg := ""
  if(!nkf_ToUTF8(sql))
  {
    $errMsg = SQLite_Exec->%$errMsg%
    return False
  }
  result := DllCall("sqlite3\sqlite3_exec",  "Uint", db
  ,"Str", sql
  ,"Uint", 0
  ,"Uint", 0
  ,"Uint *", err
  , "Cdecl int")
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_Exec:sqlite3_execG[
    return False
  }
  if(result <> 0)
  {
    error := DllCall("sqlite3\sqlite3_errmsg"
    , "Uint", db
    , "Cdecl str")
    $errMsg = SQLite_Exec:%error%
    return False
  }
  return True
}

;=========================================
;SQLite_Prepare(db, sql, ByRef query, ByRef nextSql)
;SQLites
;(SELECT)
;@:db
;       SQLite_OpenDBŎw肵ϐ
;      :sql
;       sSQLite̕ϐ
;      :query
;       Ȍgpϐ
;      :nextSql
;       sĂȂSQLite
;       ({IɎgȂdl)
;߂l: = True
;      :s = False
;=========================================
SQLite_Prepare(db, sql, ByRef query, ByRef nextSql)
{
  global $errMsg
  $errMsg := ""
  if(!nkf_ToUTF8(sql))
  {
    $errMsg = SQLite_Prepare->%$errMsg%
    return False
  }
  result := DllCall("sqlite3\sqlite3_prepare"
  , "Uint", db
  , "str", sql
  , "int", StrLen(sql)
  , "Uint *", query
  , "Uint *", nextSql
  , "Cdecl int")
  if(ErrorLevel <> 0)
  {
    if(result <> 0)
    {
      error := DllCall("sqlite3\sqlite3_errmsg"
      , "Uint", db
      , "Cdecl str")
      $errMsg = SQLite_Prepare:%error%
      return False
    }
    $errMsg = SQLite_Prepare:sqlite3_prepareG[
    return False
  }
  return True
}

;=========================================
;SQLite_GetSelect(db, sql, text, ByRef row, ByRef col)
;SELECŤʂtextŎw肵2z쐬
;@@:text"LV"̏ꍇ
;@@@ LV11 = 1s1ڂ̒l
;@@@ LV12 = 1s2ڂ̒l
;@@@ LV21 = 2s1ڂ̒l
;@:db
;       SQLite_OpenDBŎw肵ϐ
;      :sql
;       sSQLite
;      :text
;       li[ϐ
;      :row
;       ʂ̍si[ϐ
;      :col
;       ʂ̗i[ϐ
;߂l: = True
;      :s = False
;=========================================
SQLite_GetSelect(db, sql, text, ByRef row, ByRef col)
{
  Local $query, $pzTail, $rowCount, $colCount, $nowCount, $get, $result
  $errMsg := ""
  $query := 0
  $pzTail := 0
  $result := 0
  $rowCount := 0
  $colCount := 0
  $get := 0
  $result := 0
  if(!SQLite_Prepare(db, sql, $query, $pzTail))
  {
    $errMsg = SQLite_GetSelect->%$errMsg%
    return False
  }
  Loop
  {
    $result := SQLite_Step($query)
    if($result <> True)
    {
      if($result = 999)
      {
        break
      }
      $errMsg = SQLite_GetSelect->%$errMsg%
      return False
    }
    if(!SQLite_DataCount($query, $colCount))
    {
      if(A_Index == 1)
      {
        $rowCount := 0
        $colCount := 0
        break
      }
      $errMsg = SQLite_GetSelect->%$errMsg%
      return False
    }
    $rowCount := A_Index
    Loop, %$colCount%
    {
      $nowCount := A_Index - 1
      $result := SQLite_Column_Type($query, $nowCount)
      if($result == False)
      {
        $errMsg = SQLite_GetSelect->%$errMsg%
        return False
      }
      if($result == "")
      {
        $get = ""
      }
      else if($result == 1)
      {
        if(!SQLite_Column_Integer($query, $nowCount, $get))
        {
          $errMsg = SQLite_GetSelect->%$errMsg%
          return False
        }
      }
      else if($result == 2)
      {
        if(!SQLite_Column_Double($query, $nowCount, $get))
        {
          $errMsg = SQLite_GetSelect->%$errMsg%
          return False
        }
      }
      else if($result == 3)
      {
        if(!SQLite_Column_Text($query, $nowCount, $get))
        {
          $errMsg = SQLite_GetSelect->%$errMsg%
          return False
        }
      }
      else
      {
        $get = ""
      }
      %text%%$rowCount%%A_Index% := $get
    }
  }
  row := $rowCount
  col := $colCount
  SQLite_Finalize($query)
  return True
}

;=========================================
;SQLite_GetSelect_Finalize(text, row, col)
;SQLite_GetSelecťn
;@@:text"LV"̏ꍇ
;@@@ LV11 = 
;@@@ LV12 = 
;@@@ LV21 = 
;@:text
;       SQLite_GetSelectŎw肵ϐ
;      :row
;       s
;      :col
;       
;߂l:True
;=========================================
SQLite_GetSelect_Finalize(text, row, col)
{
  Local $rowCount
  $rowCount := 0
  Loop, %row%
  {
    $rowCount := A_Index
    Loop, %col%
    {
      %text%%$rowCount%%A_Index% := ""
      VarSetCapacity(%text%%$rowCount%%A_Index%, 64)
      VarSetCapacity(%text%%$rowCount%%A_Index%, 0)
    }
  }
  return True
}

;=========================================
;SQLite_Step(query)
;SQLite_PrepareŎoʂ̎1sɈړ
;@:query
;       SQLite_PrepareŎw肵ϐ
;߂l: = True
;      :I = 999
;      :s = False
;=========================================
SQLite_Step(query)
{
  global $errMsg
  $errMsg := ""
  result := DllCall("sqlite3\sqlite3_step"
  , "Uint", query
  , "Cdecl int")
  if(ErrorLevel <> 0)
  {
    if(result <> 0)
    {
      error := DllCall("sqlite3\sqlite3_errmsg"
      , "Uint", db
      , "Cdecl str")
      $errMsg = SQLite_Step:%error%
      return False
    }
    $errMsg = SQLite_Step:sqlite3_stepG[
    return False
  }
  if(result == 101)
  {
    return 999
  }
  return True
}

;=========================================
;SQLite_DataCount(query, ByRef count)
;SQLite_Prepare񂠂邩ׂ
;@:query
;       SQLite_PrepareŎw肵ϐ
;      :count
;       ʂi[ϐ
;߂l: = True
;      :s = False
;=========================================
SQLite_DataCount(query, ByRef count)
{
  global $errMsg
  $errMsg := ""
  count := DllCall("sqlite3\sqlite3_data_count"
  , "Uint", query
  , "Cdecl int")
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_DataCount:sqlite3_data_countG[
    return False
  }
  if(count < 0)
  {
    $errMsg = SQLite_DataCount:ʂ܂
    return False
  }
  return True
}

;=========================================
;SQLite_Column_Type(query, count)
;SQLite_Prepare->SQLite_StepŎw肵countڂ̌^擾
;@:query
;       SQLite_PrepareŎw肵ϐ
;      :count
;       ڂw肷
;߂l:INTEGER = 1
;      :FLOAT   = 2
;      :TEXT    = 3
;      :BLOB    = 4
;      :NULL    = ""
;      :s = False
;=========================================
SQLite_Column_Type(query, count)
{
  global $errMsg
  $errMsg := ""
  result := DllCall("sqlite3\sqlite3_column_type"
  , "Uint", query
  , "int", count
  , "Cdecl int")
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_Column_Type:sqlite3_column_typeG[
    return False
  }
  if(result == 5)
  {
    return ""
  }
  else
  {
    return result
  }
}

;=========================================
;SQLite_Column_Text(query, count, ByRef text)
;SQLite_Prepare->SQLite_StepŎw肵countڂ̃eLXg擾
;@:query
;       SQLite_PrepareŎw肵ϐ
;      :count
;       ڂw肷
;      :text
;       CeLXgi[ϐ
;߂l: = True
;      :s = False
;=========================================
SQLite_Column_Text(query, count, ByRef text)
{
  global $errMsg
  $errMsg := ""
  result := DllCall("sqlite3\sqlite3_column_text"
  , "Uint", query
  , "int", count
  , "Cdecl str")
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_Column_Text:sqlite3_column_textG[
    return False
  }
  if(!nkf_ToSJIS(result))
  {
    $errMsg = SQLite_Column_Text->%$errMsg%
    return False
  }
  text := result
  return True
}

;=========================================
;SQLite_Column_Integer(query, count, ByRef integer)
;SQLite_Prepare->SQLite_StepŎw肵countڂ̐擾
;@:query
;       SQLite_PrepareŎw肵ϐ
;      :count
;       ڂw肷
;      :integer
;       Ci[ϐ
;߂l: = True
;      :s = False
;=========================================
SQLite_Column_Integer(query, count, ByRef integer)
{
  global $errMsg
  $errMsg := ""
  integer := DllCall("sqlite3\sqlite3_column_int"
  , "Uint", query
  , "int", count
  , "Cdecl int")
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_Column_Integer:sqlite3_column_intG[
    return False
  }
  return True
}

;=========================================
;SQLite_Column_Double(query, count, ByRef double)
;SQLite_Prepare->SQLite_StepŎw肵countڂ̏擾
;@:query
;       SQLite_PrepareŎw肵ϐ
;      :count
;       ڂw肷
;      :integer
;       Ci[ϐ
;߂l: = True
;      :s = False
;=========================================
SQLite_Column_Double(query, count, ByRef double)
{
  global $errMsg
  $errMsg := ""
  double := DllCall("sqlite3\sqlite3_column_double"
  , "Uint", query
  , "int", count
  , "Cdecl double")
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_Column_Double:sqlite3_column_doubleG[
    return False
  }
  return True
}

;=========================================
;SQLite_Finalize(query)
;SQLite_PrepareI
;@:query
;       SQLite_PrepareŎw肵ϐ
;߂l: = True
;      :s = False
;=========================================
SQLite_Finalize(query)
{
  global $errMsg
  $errMsg := ""
  DllCall("sqlite3\sqlite3_finalize"
  , "Uint", query
  , "Cdecl int")
  if(ErrorLevel <> 0)
  {
    $errMsg = SQLite_Finalize:sqlite3_finalizeG[
    return False
  }
  return True
}